/*
     This file is part of GNUnet.
     (C) 2001, 2002 Christian Grothoff (and other contributing authors)

     GNUnet is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published
     by the Free Software Foundation; either version 2, or (at your
     option) any later version.

     GNUnet is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with GNUnet; see the file COPYING.  If not, write to the
     Free Software Foundation, Inc., 59 Temple Place - Suite 330,
     Boston, MA 02111-1307, USA.
*/

/**
 * Helper functions for downloading.
 *
 * @author Christian Grothoff
 * @file include/applications/afs/encoding/downloadutil.h
 **/

#ifndef DOWNLOADUTIL_H
#define DOWNLOADUTIL_H

#include "config.h"
#include "applications/afs/protocol/messages.h"
#include "applications/afs/encoding/block.h"


/**
 * Download a file.
 *
 * @param fi the file identifier 
 * @param fileName the name of the file
 * @param model the download model used to
 *        update status information; points to NULL if
 *        no status updates shall be given
 * @param data pointer that is passed to the model method.
 * @return a request manager that can be used to abort on 
 *         success, NULL on error
 **/
RequestManager * downloadFile(FileIdentifier * fi,
			      char * fileName,
			      ProgressModel model,
			      void * data);

#endif
/* end of downloadutil.h */
